Multivariate Pattern Analysis in Python

# mvpa2.base.node.CompoundNode

class `mvpa2.base.node.``CompoundNode`(nodes, **kwargs)

  List of nodes.

  A CompoundNode behaves similar to a list container: Nodes can be appended, and the chain can be sliced like a list, etc ...

  Subclasses such as ChainNode and CombinedNode implement the _call method in different ways.

  Notes

  Available conditional attributes:

  - `calling_time+`: Time (in seconds) it took to call the node
  - `raw_results`: Computed results before invoking postproc. Stored only if postproc is not None.

  (Conditional attributes enabled by default suffixed with `+`)

  Attributes

  `descr` | Description of the object if any
  `nodes` |
  `pass_attr` | Which attributes of the dataset or self.ca to pass into result dataset upon call
  `postproc` | Node to perform post-processing of results
  `space` | Processing space name of this node

  Methods

  `__call__`(ds) | The default implementation calls `_precall()`, `_call()`, and finally returns the output of `_postcall()`.
  `append`(node) | Append a node to the chain.

  `generate`(ds[, startnode])

  Parameters: |

  `get_postproc`() | Returns the post-processing node or None.
  `get_space`() | Query the processing space name of this node.
  `set_postproc`(node) | Assigns a post-processing node
  `set_space`(name) | Set the processing space name of this node.

  Parameters:

  nodes: list

  > Node instances.

  enable_ca : None or list of str

  > Names of the conditional attributes which should be enabled in addition to the default ones

  disable_ca : None or list of str

  > Names of the conditional attributes which should be disabled

  space : str, optional

  > Name of the ‘processing space’. The actual meaning of this argument heavily depends on the sub-class implementation. In general, this is a trigger that tells the node to compute and store information about the input data that is “interesting” in the context of the corresponding processing in the output dataset.

  pass_attr : str, list of str|tuple, optional

  > Additional attributes to pass on to an output dataset. Attributes can be taken from all three attribute collections of an input dataset (sa, fa, a – see `Dataset.get_attr()`), or from the collection of conditional attributes (ca) of a node instance. Corresponding collection name prefixes should be used to identify attributes, e.g. ‘ca.null_prob’ for the conditional attribute ‘null_prob’, or ‘fa.stats’ for the feature attribute stats. In addition to a plain attribute identifier it is possible to use a tuple to trigger more complex operations. The first tuple element is the attribute identifier, as described before. The second element is the name of the target attribute collection (sa, fa, or a). The third element is the axis number of a multidimensional array that shall be swapped with the current first axis. The fourth element is a new name that shall be used for an attribute in the output dataset. Example: (‘ca.null_prob’, ‘fa’, 1, ‘pvalues’) will take the conditional attribute ‘null_prob’ and store it as a feature attribute ‘pvalues’, while swapping the first and second axes. Simplified instructions can be given by leaving out consecutive tuple elements starting from the end.

  postproc : Node instance, optional

  > Node to perform post-processing of results. This node is applied in `__call__()` to perform a final processing step on the to be result dataset. If None, nothing is done.

  descr : str

  > Description of the instance

  Attributes

  `descr` | Description of the object if any
  `nodes` |
  `pass_attr` | Which attributes of the dataset or self.ca to pass into result dataset upon call
  `postproc` | Node to perform post-processing of results
  `space` | Processing space name of this node

  Methods

  `__call__`(ds) | The default implementation calls `_precall()`, `_call()`, and finally returns the output of `_postcall()`.
  `append`(node) | Append a node to the chain.

  `generate`(ds[, startnode])

  Parameters: |

  `get_postproc`() | Returns the post-processing node or None.
  `get_space`() | Query the processing space name of this node.
  `set_postproc`(node) | Assigns a post-processing node
  `set_space`(name) | Set the processing space name of this node.

  `append`(node)

    Append a node to the chain.

  `generate`(ds, startnode=0)

    Parameters:

    ds: Dataset

    > To be processed dataset

    startnode: int

    > First node in the chain that shall be considered. This argument is mostly useful for internal optimization.

  `nodes`